<?php
error_reporting(E_ALL & ~E_NOTICE);
/**
 * @brief index.php
 *
 * Main file of IronCMS - loads other files
 * @author Sobak
 * @version 1.0
 */

/**
 * Buffering is necessary
 *
 * Start session
 */
ob_start();
session_start();

/**
 * Start debug. Total script time and queries counter
 *
 * Debug will show in theme's footer.php file
 */
$scriptTimeStart = microtime(true);
$queriesCounter = 0;

/**
 * Set used variables (anty-notice)
 */
$cfg = array();
$isInWebs = false;

/**
 * Load necessary files
 * Check whether config.php exists
 */

if (file_exists('config.php')) {
    require_once 'config.php';
}

else {
    die ('Cannot load configuration!');
}

if (file_exists('modules/logger.class.php')) {
    require_once 'modules/logger.class.php';
}

else {
    die ('Cannot load logger class!');
}


if (file_exists('modules/functions.php')) {
    require_once 'modules/functions.php';
}

else {
    die ('Cannot load functions.php!');
}


/**
 * load_module() is now included
 * logger is needed to handle errors
 *
 * create array which loaded modules
 */
$loadedModules = array();
loadModule ('db');
loadModule('user');

/**
 * Connect to database
 */
dbConnect();

/**
 * Set necessary variables and do other important things :P
 */

if ($_COOKIE['icms_theme'] != '') {
    define ('THEME', $_COOKIE['icms_theme']);
}

else {
    define('THEME', getSetting('theme'));
}

if (usIsLogged ()) {
    $user = usGet('', '');
}

/**
 * URL routing section
 * explode address by slash
 */
$addr = splitAddr($_SERVER['QUERY_STRING']);


/**
 * Save the first element of an address to the variable $id
 */
$id = $addr[0];

/**
 * Load theme's functions
 */
if (file_exists('themes/'.THEME.'/functions.php')) {
    require_once 'themes/'.THEME.'/functions.php';
}

else {
    logger::add_event (2, __FILE__, __LINE__, "Theme's functions.php file doesn't exists");
}

/**
 * Check where the page is:
 *  - in database? - page added in admin panel
 *  - in webs/ directory? - php file (as ex. contact page, search itd)
 *  - page doesn't exists - show error 404
 */

/**
 * If $id is empty show main page
 */
if (empty ($id) or !isset($id)) {
    $home_id = getSetting('home_id'); // Get id of page shows as a main page

    if ($home_id != '') { // If $home_id isn't set, then use "main_page" ID (default)
     $id = 'main_page';
    }

    else {
     $id = $home_id;
     }
    
}

/**
 * If cache file doesn't extists, get page from database and save it to cache
 */

/**
 * Check whether page exists in database
 */
$existsContent = mysql_fetch_array(dbQuery("SELECT COUNT(*) FROM {prefix}content WHERE id = '$id'"));


/**
 * Page exists in database - show it!
 */
if ($existsContent[0] != 0) {
 $content = mysql_fetch_array(dbQuery("SELECT * FROM {prefix}content WHERE id = '$id'"));

 /**
  * But first check that page isn't in trash
  * if it is, then show eror 404
  */
 if ($content['in_trash'] == 1) {
    $content = mysql_fetch_array(dbQuery("SELECT * FROM {prefix}static WHERE id = 'error_404'"));
    $isInWebs = true;
    $id = 'error_404';
 }
}


elseif (file_exists("webs/$id.php")) {
   /**
    * If page exists in webs, then check that it have entry in database
    */
    $existsStatic = mysql_fetch_array(dbQuery("SELECT COUNT(*) FROM {prefix}static WHERE id = '$id'"));

    if ($existsStatic[0] != 0) {
        /**
         * Entry in db exists too, include page
         */
        $isInWebs = true;
        $content = mysql_fetch_array(dbQuery("SELECT * FROM {prefix}static WHERE id = '$id'"));
    }
}

    /**
     * PHP file exists, but it haven't entry in database
     * Show error 404
     */
    elseif ($existsContent[0] == 0 and $existsStatic[0] == 0) {
        $content = mysql_fetch_array(dbQuery("SELECT * FROM {prefix}content WHERE id = 'error_404'"));
        $id = 'error_404';
        $isInWebs = false;
    }


/**
 * Load header file
 */
loadModule('bbcode.class');
loadModule('seo');
require_once 'themes/'.THEME.'/header.php';


/**
 * If page with that id is *.php file, then include it!
 */
if ($isInWebs == true) {
 require_once ('webs/'.$id.'.php');
}

/**
 * Else show page content from database
 */
else {
    $bbcode = new bbcode();
    echo $bbcode ->parse($content['content']);


 // Comments "engine"
 loadModule('comments');
 commentsShow ();
 commentsForm ();

}


/**
 * Include theme's footer
 */
require_once 'themes/'.THEME.'/footer.php';

 ob_end_flush ();
?>