<?php
/**
 * @brief functions.php
 *
 * Main function needed to all modules
 * @author Sobak
 * @version 1.0
 */

/**
 * @brief loadModule
 *
 * @param $module_name <string>
 * @return <boolean>
 */
function loadModule ($moduleName) {
    global $loadedModules;

    if (file_exists ("modules/$moduleName.php")) {
        $loadedModules[] = $moduleName;
        require "modules/$moduleName.php";
    }

    else {
        logger::add_event (1, __FILE__, __LINE__, 'Cannot load module: '.$moduleName);
        return false;
    }
}

function isModuleLoaded ($moduleName) {
    global $loadedModules;

    if (in_array($moduleName, $loadedModules)) return true;
}

/**
 * Gets setting from config table in database
 *
 * @param $set <string>
 * @return setting <string/int/float>
 */
function getSetting ($set) {
    $setting = mysql_fetch_array(dbQuery ("SELECT value FROM {prefix}settings WHERE setting = '$set' LIMIT 1;"));
    return $setting[0];
}

function splitAddr ($addr) {
    $addrElements = explode ('/', dbSecure($addr));

    return $addrElements;
}

function clearCache ($id = '') {
    if ($id != '') {
        unlink('cache/'.md5($id));
    } else {
        rmdir('cache');
        mkdir('cache');
    }
}

function changeTheme ($theme) {
    $cookie = setcookie('theme', $theme, 60*60*24);

    if (!$cookie) {
        return false;
    }
}

function showDebugInfo () {
    global $cfg, $scriptTimeStart, $queriesCounter;

    if ($cfg['debug']) {
           echo 'Debug - czas wykonywania: '.round(microtime(true)-$scriptTimeStart, 3).' sek. | zapytań: '.$queriesCounter;
    }
}

function randomString ($limit) {
  return substr(md5(date("d.m.Y.H.i.s").rand(1,1000000)) , 0 , $limit);
}
?>